<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>fhir-decease-status</title>

    <script src="../../node_modules/@webcomponents/webcomponentsjs/webcomponents-bundle.js"></script>
    <script src="../../node_modules/wct-browser-legacy/browser.js"></script>

    <!-- Import the element to test -->
    <script type="module" src="../../packages/fhir-decease-status/fhir-decease-status.js"></script>
</head>
<body>
<test-fixture id="DefaultElement">
    <template>
        <fhir-decease-status url="/load_patient_data"></fhir-decease-status>
    </template>
</test-fixture>
<dom-bind>
    <test-fixture id="SetValue">
        <template>
            <fhir-decease-status id="fhirDecease" value="[[deceases]]"></fhir-decease-status>
        </template>
    </test-fixture>
</dom-bind>


<script type="module">
    import patient2 from '../../test/testResources/patient2.js';

    suite('<iron-ajax>', function () {
        var ajax;
        var request;
        var server;
        var decease;
        var responseHeaders = {
            json: {'Content-Type': 'application/json'}
        };
        setup(function () {
            server = sinon.fakeServer.create();
            server.respondImmediately = true;
            server.respondWith('GET', /\/load_patient_data.*/,
                [200,
                    {'Content-Type': 'application/json'},
                    JSON.stringify(patient2)
                ]
            );
        });
        teardown(function () {
            server.restore();
        });

        suite('fhir-decease-status tests', function () {
            setup(function () {
                decease = fixture('DefaultElement');
            });

            test('Decease state of patient2 is false', function () {
                decease.addEventListener('iron-ajax-response', function (done) {
                    flush(function () {
                        var deceased = decease.shadowRoot.querySelector('.decease').checked;
                        assert.equal(deceased, false);
                        assert.notEqual(deceased, true);
                        done();
                    });
                });
            });
            test('To check if value sets correctly to each field', function (done) {
                document.querySelector('dom-bind').set('deceases', patient2.deceasedBoolean);
                flush(function () {
                    let cont = document.getElementById('fhirDecease').shadowRoot.querySelector('.decease').checked;
                    assert.equal(cont, false);
                    assert.notEqual(cont, true);
                    done();
                });
            });

        });
    });
</script>
</body>
</html>